// Copyright (c) 2015, Meshulam Silk (moomoohk@ymail.com). All rights reserved. Use of this source code
// is governed by a BSD-style license that can be found in the LICENSE file.

part of geek_code.v312;

/**
 * Geek Code types specified in the Original Geek Code v3.12 specification.
 */
class G312 {

  /**
   * Original documentation:
   *
   *     Geek of Business
   */
  static final GeekCodeType B = new GeekCodeType("B");

  /**
   * Original documentation:
   *
   *     Geek of Classics
   */
  static final GeekCodeType C = new GeekCodeType("C");

  /**
   * Original documentation:
   *
   *     Geek of Commercial Arts
   */
  static final GeekCodeType CA = new GeekCodeType("CA");

  /**
   * Original documentation:
   *
   *     Geek of Computer Management
   */
  static final GeekCodeType CM = new GeekCodeType("CM");

  /**
   * Original documentation:
   *
   *     Geek of Computer Science
   */
  static final GeekCodeType CS = new GeekCodeType("CS");

  /**
   * Original documentation:
   *
   *     Geek of Communications
   */
  static final GeekCodeType CC = new GeekCodeType("CC");

  /**
   * Original documentation:
   *
   *     Geek of Engineering
   */
  static final GeekCodeType E = new GeekCodeType("E");

  /**
   * Original documentation:
   *
   *     Geek of Education
   */
  static final GeekCodeType ED = new GeekCodeType("ED");

  /**
   * Original documentation:
   *
   *     Geek of Fine Arts
   */
  static final GeekCodeType FA = new GeekCodeType("FA");

  /**
   * Original documentation:
   *
   *     Geek of Government
   */
  static final GeekCodeType G = new GeekCodeType("G");

  /**
   * Original documentation:
   *
   *     Geek of Humanities
   */
  static final GeekCodeType H = new GeekCodeType("H");

  /**
   * Original documentation:
   *
   *     Geek of Information Technology
   */
  static final GeekCodeType IT = new GeekCodeType("IT");

  /**
   * Original documentation:
   *
   *     Geek of Jurisprudence (Law)
   */
  static final GeekCodeType J = new GeekCodeType("J");

  /**
   * Original documentation:
   *
   *     Geek of Library Science
   */
  static final GeekCodeType LS = new GeekCodeType("LS");

  /**
   * Original documentation:
   *
   *     Geek of Literature
   */
  static final GeekCodeType L = new GeekCodeType("L");

  /**
   * Original documentation:
   *
   *     Geek of Mass Communications
   */
  static final GeekCodeType MC = new GeekCodeType("MC");

  /**
   * Original documentation:
   *
   *     Geek of Math
   */
  static final GeekCodeType M = new GeekCodeType("M");

  /**
   * Original documentation:
   *
   *     Geek of Medicine
   */
  static final GeekCodeType MD = new GeekCodeType("MD");

  /**
   * Original documentation:
   *
   *     Geek of Music
   */
  static final GeekCodeType MU = new GeekCodeType("MU");

  /**
   * Original documentation:
   *
   *     Geek of Performing Arts
   */
  static final GeekCodeType PA = new GeekCodeType("PA");

  /**
   * Original documentation:
   *
   *     Geek of Philosophy
   */
  static final GeekCodeType P = new GeekCodeType("P");

  /**
   * Original documentation:
   *
   *     Geek of Science (Physics, Chemistry, Biology, etc.)
   */
  static final GeekCodeType S = new GeekCodeType("S");

  /**
   * Original documentation:
   *
   *     Geek of Social Science (Psychology, Sociology, etc.)
   */
  static final GeekCodeType SS = new GeekCodeType("SS");

  /**
   * Original documentation:
   *
   *     Geek of Technical Writing
   */
  static final GeekCodeType TW = new GeekCodeType("TW");

  /**
   * Original documentation:
   *
   *     Geek of Other. Some types of geeks deviate from the normal geek activities. This is encouraged as true geeks come from all walks of life.
   */
  static final GeekCodeType O = new GeekCodeType("O");

  /**
   * Original documentation:
   *
   *     Geek of 'Undecided'. This is a popular vocation with incoming freshmen.
   */
  static final GeekCodeType U = new GeekCodeType("U");

  /**
   * Original documentation:
   *
   *     Geek of All Trades. For those geeks that can do anything and everything. GAT usually precludes the use of other vocational descriptors.
   */
  static final GeekCodeType AT = new GeekCodeType("AT");
}
